int num_colours = 7;

#define max_grid_width 32
#define max_grid_height 32

#define MAX_COLOURS 7

enum
{
	TILE_TYPE_HEXAGON = 0,
	TILE_TYPE_RECTANGLE,
	TILE_TYPE_TRIANGLE,
};


#define grid_width_rect 20
#define grid_height_rect 16		

// we can't make it 18 unless we make the height of rectangles 12 and make the width 6

//#define grid_height_rect 18

#define grid_width_tri 21
#define grid_height_tri 11
//#define grid_height_tri 2

// 30 is too tall for 32 li
#define max_grid_width 32
#define max_grid_height 32

//#define max_grid_width max(grid_width_rect, max(grid_width_hex, grid_width_tri))
//#define max_grid_height max(grid_height_rect, max(grid_height_hex, grid_height_tri))
#define play_grid_width 32
#define grid_width_hex 10
#define grid_height_hex 32

#define MOVE_SEQUENCE_MAX 128
#define VALUE_MASK  0x07
#define VALUE_INFECTED 0x040
#define CONSIDERED_ALL_SIDES  0x080
//#define max_grid_width max(grid_width_rect, max(grid_width_hex, grid_width_tri))
//#define max_grid_height max(grid_height_rect, max(grid_height_hex, grid_height_tri))
#define play_grid_width 32
static unsigned char move_stack_x[max_grid_width*max_grid_height];	
static unsigned char move_stack_y[max_grid_width*max_grid_height];	
static unsigned char play_grid[play_grid_width*max_grid_height]; 
char move_sequence[MOVE_SEQUENCE_MAX];
int move_count;
static  unsigned char cur_value;
static  unsigned char sel_value;
static unsigned int soundtype;
static unsigned int tiletype;
static unsigned int tilenumsides;
static unsigned char old_sel_value;
static  unsigned int nvirus;
static unsigned int grid_width, grid_height; // width/height
static unsigned int grid_total;		// total number of squares
//static unsigned int nmovesleft;
//static unsigned int totalmoves;
static unsigned int nmovescur;
static unsigned int nmovesmin;
static unsigned char *currentmusic;
static unsigned int minmoves;
static unsigned char state;
static unsigned char backstate;
static unsigned char mainstate;
static unsigned char game_quit;
static volatile unsigned char RandomSeed;
static unsigned char GameSeed;
static volatile unsigned char VsyncMark;
static unsigned int delay;
int num_useable[MAX_COLOURS];
/***************************************************************/
/* do x and y coordinates reference a valid cell? */

int is_valid_cell(int x, int y)
{
	/* was seperate ifs, but this resulted in multiple return 0 being emitted as code */
	/* doing a direct return gives worse code than returning 0 or 1 */
	if (
		(x<0) || 
		(y<0) ||
		(x>=grid_width) ||
		(y>=grid_height)
	)
	{
		return 0;
	}
	
	return 1;
}

/***************************************************************/
/* get value from play grid at the x,y coordinates - x,y must be valid */

unsigned char *get_play_grid_addr(int x, int y)
{
	// calc address in play grid
	int element = (y*play_grid_width)+x;
	// calc address of play grid
	return &play_grid[element];
}

/***************************************************************/

unsigned char get_grid_value(int x,int y)
{
	return get_play_grid_addr(x,y)[0];
}

/***************************************************************/
void infect_grid_cell(int x,int y)
{	
	get_play_grid_addr(x,y)[0]|=VALUE_INFECTED;
}

/***************************************************************/
void uninfect_grid_cell(int x,int y)
{	
	get_play_grid_addr(x,y)[0]&= ~VALUE_INFECTED;
}

/***************************************************************/
void set_all_sides_considered(int x, int y)
{
	get_play_grid_addr(x,y)[0]|= CONSIDERED_ALL_SIDES;
}

/***************************************************************/

void clear_all_sides_considered(int x, int y)
{
	get_play_grid_addr(x,y)[0]&= ~CONSIDERED_ALL_SIDES;
}

/***************************************************************/

void get_neighbour_cell_hex(int x, int y, int *nx, int *ny, int s)
{
	switch (s)
	{
		/* a */
		case 0:
		{
			*nx = x;
			*ny = y-2;
		}
		break;
		
		/* b */
		case 1:
		{
			if ((y&1)==0)
			{
				/* even */
				*nx = x;
				*ny = y-1;
			}
			else
			{
				/* odd */
				*nx = x+1;
				*ny = y-1;
			}
		}
		break;
		
		/* c */
		case 2:
		{
			if ((y&1)==0)
			{
				/* even */
				*nx = x;
				*ny = y+1;
			}
			else
			{
				/* odd */
				*nx = x+1;
				*ny = y+1;
			}
		}
		break;

		/* d */
		case 3:
		{
			*nx = x;
			*ny = y+2;
		}
		break;

		/* e */
		case 4:
		{
			if ((y&1)==0)
			{
				/* even */
				*nx = x-1;
				*ny = y+1;
			}
			else
			{
				/* odd */
				*nx = x;
				*ny = y+1;
			}
		}
		break;

		/* f */
		case 5:
		{
			if ((y&1)==0)
			{
				/* even */
				*nx = x-1;
				*ny = y-1;
			}
			else
			{
				/* odd */
				*nx = x;
				*ny = y-1;
			}
		}
		break;
		
		default:
		{
			*nx = x;
			*ny = y;
		}
		break;
	}
}

/***************************************************************/

/*
      0
    +-----+
  3 |     | 1
    +-----+
      2
*/

void get_neighbour_cell_rect(int x, int y, int *nx, int *ny, int s)
{
    switch (s)
  {
      case 0:
      {
          *nx = x;
          *ny = y-1;
      }
      break;
      
      case 1:
      {
         *nx = x+1;
         *ny = y;
      }
      break;
      
      case 2:
      {
        *nx = x;
        *ny = y+1;
      }
      break;
      
      case 3:
      {
        *nx = x-1;
        *ny = y;
      }
      break;
      
      default:
        	{
			*nx = x;
			*ny = y;
		}
		break;
  }
}
  
/***************************************************************/

/*


  _ _ _ _ _ _ _ _
/\/\/\/\/\/\/\/\/\
------------------
\/\/\/\/\/\/\/\/\/

0
 --
2\/ 1


2/\0
 --
1

even x, even y -> /\

0: x->x+1, y->y
1: x->x, y->y+1
2: x->x-1, y->y

odd x, even y -> \/

0: x->x, y->y-1
1: x->x+1, y->y
2: x->x-1, y->y

even x, odd y -> \/

0: x->x, y->y-1
1: x->x+1, y->y
2: x->x-1, y->y

odd x, odd y -> /\

0: x->x+1, y->y
1: x->x, y->y+1
2: x->x-1, y->y
*/

void get_neighbour_cell_tri(int x, int y, int *nx, int *ny, int s)
{
  switch (s)
  {
      case 0:
      {
          if (((x^y)&1)!=0)
          {
            /* x and y are not both odd/even */
            *nx = x;
            *ny = y-1;
          }
          else
          {
            *nx = x+1;
            *ny = y;
          }
      }
      break;
      
      case 1:
      {
          if (((x^y)&1)!=0)
          {
            /* x and y are not both odd/even */
            *nx = x+1;
            *ny = y;
          }
          else
          {
            *nx = x;
            *ny = y+1;
          }
      }
      break;
      
      case 2:
      {
          *nx = x-1;
          *ny = y;
      }
      break;
          
      default:
        	{
			*nx = x;
			*ny = y;
		}
		break;
  }
}

/***************************************************************/
/* based on x,y position and side, give new x,y coordinates for neighbour cell; note coords may not be valid */
void get_neighbour_cell(int x, int y, int *nx, int *ny, int s)
{
	switch (tiletype)
	{
		default:
		case TILE_TYPE_HEXAGON:
			return get_neighbour_cell_hex(x,y,nx,ny,s);
		case TILE_TYPE_RECTANGLE:
			return get_neighbour_cell_rect(x,y,nx,ny,s);
		case TILE_TYPE_TRIANGLE:
			return get_neighbour_cell_tri(x,y,nx,ny,s);
	}
}	


/***************************************************************/
/* loop over and remove considered from neighbour cells, this ensures we can reconsider them */
void clear_considered(int x,int y)
{
	int s;
	/* loop over each side */
	for (s=0; s<tilenumsides; s++)
	{
		int x2,y2;

		/* get x,y coord from current position */
		get_neighbour_cell(x,y, &x2, &y2,s);
		
		if (is_valid_cell(x2,y2))
		{
			clear_all_sides_considered(x2,y2);
		}
	}		
	
}

/***************************************************************/
/* remove position from history */

void remove_last_pos()
{
	if (nvirus!=0)
	{
		// go back a virus
		--nvirus;

		// uninfect this cell
		uninfect_grid_cell(move_stack_x[nvirus], move_stack_y[nvirus]);

		// now potentially we need to go back and mark those that
		// had all sides considered to unmark them
		// and they are unlikely to be immediately previous in the list.
		// we could remove it from all neighbours, but that's a bit slow
		clear_considered(move_stack_x[nvirus], move_stack_y[nvirus]);
	}
}


/***************************************************************/
/* add a position to the history, infect the cell, and cause the display to be updated */
void add_pos(int x,int y)
{

	/* store move made */
	move_stack_x[nvirus] = x;
	move_stack_y[nvirus] = y;
	nvirus++;
	
	/* infect the cell */
	infect_grid_cell(x,y);
	
	printf("nvirus: %d\n", nvirus);
	//state = STATE_DRAW_INFECTED_CELL;
}

/***************************************************************/
/* update the infection one cell at a time */

char update_infections()
{
	char infected = 0;

	
	/* go back through the list of cells */
	int i = nvirus-1;

	while (i>=0)
	{
		int x,y;
		unsigned char val;
		
	
		/* get x,y values */
		x = move_stack_x[i];
		y = move_stack_y[i];
		
		/* get value */
		val = get_grid_value(x,y);
		
		/* did we consider all sides already? */
		if ((val & CONSIDERED_ALL_SIDES)==0)
		{
			int s;
			/* side to infect */
			int nsideinfect = -1;
			
			/* number of sides to infect */ 
			int nsidesinfected = 0;
			
			/* loop over each side */
			for (s=0; s<tilenumsides; s++)
			{
				int x2,y2;

				/* get x,y coord from current position */
				get_neighbour_cell(x,y, &x2, &y2,s);
				
				if (is_valid_cell(x2,y2))
				{
					/* current value? */
					unsigned char neighbourval = get_grid_value(x2, y2);
					
					/* update number of sides infected */
					if ((neighbourval & VALUE_INFECTED)!=0)
					{
						++nsidesinfected;
					}
					else
					{	
						/* get value */
						neighbourval &= VALUE_MASK;
						
						/* we did not infect a side yet, and the side has the value we are looking for */
						if ((nsideinfect==-1) && (neighbourval==cur_value))
						{
							nsideinfect = s;
							
							/* add and break out of the loop; we infected a new cell */
							add_pos(x2,y2);

							infected = 1;
              
              			
						}
					}
				}
	
				/* if we just infected all sides, mark it as totally infected so we ignore next time */
				if ((nsidesinfected==(tilenumsides-1)) && infected)
				{
					set_all_sides_considered(x,y);
				}
			
				/* if we just made an infection, quit out now */
				if (infected)
					break;
			}

		/* we infected a new cell! */
		if (infected)	
			break;

		}
		
		/* we didn't infect a cell */
		
		/* go back */	
		--i;
	}
	return infected;
}


void cpc_SetRandSeed()
{
}

int cpc_RandomInRange(int nrange)
{
	return rand()%nrange;
}

void grid_init()
{	
	//int i;
	unsigned char *pGrid = play_grid;
  
	/* ensure we don't get a random seed of 0 */
	{
		/* initialise random seed */
		int Seed = GameSeed;
		if (Seed==0)
		{
			/* some default seed */
			Seed=0x0aa;
		}
			
		cpc_SetRandSeed(Seed);
	}

  {
	unsigned char *pGridCur = pGrid;
	int y,x;
    /* number of elements in grid */
    /* number of each colour when shared between them all */
    int num_each = grid_total/num_colours;
    /* this is the number of chooseable colours; when some reach 0 count, we can't choose them anymore */
    int num_chooseable_colours = num_colours;
    int c;
    /* initialise number of each colours we can choose */
    for (c = 0; c<num_colours; c++)
    {
        num_useable[c] = num_each;
    }
   
    for (y = grid_height; y!=0; y--) 
    {	
		unsigned char *pGridStore = pGridCur;
	
		for (x = grid_width; x!=0; x--)
		{
			  int colour=0;
			  /* if we exhausted each colour */
			  if (num_chooseable_colours==0)
			  {
				/* choose a random one to fill in */
				colour = cpc_RandomInRange(num_colours);
			  }
			  else
			  {
				/* choose from one of the available colours */
				int colour_index = cpc_RandomInRange(num_chooseable_colours);
				for (c=0; c<num_colours; c++)
				{
					/* find which it is */
					int num_useable_this_colour = num_useable[c];
					if (num_useable_this_colour!=0)
					{
						/* is this the one we wanted? */
						if (colour_index==0)
						{
						  /* found it */
						  colour = c;
						  
						  num_useable_this_colour--;
						  /* we used up all it's supply? */
						  if (num_useable_this_colour==0)
						  {
							/* one less colour to choose from */
							  num_chooseable_colours--;
						  }
						  /* update how many are remaining */
						  num_useable[c] = num_useable_this_colour;
						  break;
					  }
					  else
					  {
						  /* this one is useable */
						  colour_index--;
					  }
					}
				}
			  }
					
			  *pGridCur = colour;
			  ++pGridCur;
		}
		pGridCur = pGridStore;
		pGridCur += play_grid_width;
	}
  }
    printf("grid init done\n");
#if 0	
  // totally random is not good.
	for (i = 0; i < grid_total; i++) 
	{	
		/* random number between 0 and 6 */
		*pGrid = cpc_RandomInRange(7);
		++pGrid;
	}
  #endif
}


/***************************************************************/
/* start the game, we infect the bottom-left cell, this may spark infections based on it's value and it's neighbours */
int find_min_moves();

void new_game()
{
	int x,y;
	
	/* number of moves so far */
	nvirus = 0;
	
	nmovescur = 0;
	//nmovesleft = totalmoves;
	
	/* initialise play grid */
	grid_init();

	// setup initial move
	switch (tiletype)
	{
		default:
		case TILE_TYPE_HEXAGON:
		{
      if ((grid_height & 1)==0)
      {
        x = 0;
        y = grid_height-2;
      }
      else
      {
         x = 0;
         y = grid_height-1;
      }

		}
		break;
		
		case TILE_TYPE_RECTANGLE:
		{
        x = 0;
       y = grid_height-1;
		}
		break;
		
		case TILE_TYPE_TRIANGLE:
		{
			x = 0;
			y = grid_height-1;
		}
		break;
	}
	
	/* this is the current value */
  set_colour_choice(get_grid_value(x,y));
  
  /* selected values */
  old_sel_value = cur_value;
  sel_value = cur_value;
	
	/* now infect and start the process */
	add_pos(x,y);
	
	/* find minimum number of moves */
	nmovesmin = find_min_moves();
	
	
}


// using best we got 26 moves initially.
// for each we should rate according to best, then choose next best etc
//
// x moves, x bests
int find_min_moves()
{
    char infected;
    int move_wanted = cur_value;
    int s;
	int init_cur_value = cur_value;
	int nvirusbegin;
	
	printf("find min moves\n");
	// reset move count
	move_count = 0;
	
	// perform initial infection using current square, this is the first move given to you
    do
    {
        infected = update_infections();
    }
    while (infected!=0);

    nvirusbegin = nvirus;
    // best could be 5 or 6 for initial

	do
	{
        int best_infected = -1;
        int best_move = -1;

        for (move_wanted=0; move_wanted<num_colours; move_wanted++)
        {
            int total_infected;
            int nvirusbefore = nvirus;

		// skip if this is our current value
             if (move_wanted==cur_value)
                    continue;

            // set the new move
            cur_value = move_wanted;

	     // count infections
            total_infected = 0;

            // update the infection until it's done
            // count the number of moves as it does it.
            do
            {
                infected = update_infections();
                if (infected!=0)
                {
                    total_infected++;
                }
            }
            while (infected!=0);
		printf("tot: %d\n",total_infected);
	
		// undo this move
             while (nvirus!=nvirusbefore)
            {
                remove_last_pos();
            }
	    
            if ((best_infected==-1) || (total_infected>best_infected))
            {
		    // best so far
                best_infected = total_infected;
                best_move = cur_value;
            }
        }
        
        // update infection
        cur_value = best_move;
        do
        {
            infected = update_infections();
        }
        while (infected!=0);
	
	// this move is good, store it.
        move_sequence[move_count] = best_move;
        ++move_count;
	
	// keep going until all are infected
	}
	while (nvirus!=grid_total);
	
	// now we found our best moves, we need to go back and undo all the moves
	
	// restore initial value
	cur_value = init_cur_value;
	
	// not the best undo this move.
	while (nvirus!=nvirusbegin)
	{
		remove_last_pos();
	}
	
	return move_count;
}

/***************************************************************/
/* update the choice colour */
void set_colour_choice(int choice)
{
  cur_value = choice;
}

void main()
{
	int i;
	
	tiletype = TILE_TYPE_HEXAGON;
	
	

	switch (tiletype)
	{
		default:
		case TILE_TYPE_HEXAGON:
		{
//			totalmoves = MOVES_MAX;
//			minmoves = MOVES_MIN;
			tilenumsides = 6;
			grid_width = grid_width_hex;
			grid_height = grid_height_hex;
			grid_total = grid_width_hex*grid_height_hex;
		}
		break;
		
		case TILE_TYPE_TRIANGLE:
		{
//			totalmoves = MOVES_MAX_TRI;
//			minmoves = MOVES_MIN_TRI;
			tilenumsides = 3;
			grid_width = grid_width_tri;
			grid_height = grid_height_tri;
			grid_total = grid_width_tri*grid_height_tri;
		}
		break;

		case TILE_TYPE_RECTANGLE:
		{
	//		totalmoves = MOVES_MAX_RECT;
	//		minmoves = MOVES_MIN_RECT;
			tilenumsides = 4;
			grid_width = grid_width_rect;
			grid_height = grid_height_rect;
			grid_total = grid_width_rect*grid_height_rect;
		}
		break;
	}		
	new_game();
	
	printf("count: %d\n", move_count);
	
	for (i=0; i<move_count; i++)
	{
		printf("%d\n",move_sequence[i]);
	}
	
	for (i=0; i<move_count; i++)
	{
		int infected = 0;
		cur_value = move_sequence[i];
			
		// perform initial infection using current square, this is the first move given to you
	    do
	    {
		infected = update_infections();
	    }
	    while (infected!=0);

    }
    printf("nvirus: %d\n", nvirus);
	
}
	
