;; disc loader 
;; similar loader can be used for cassette
;; this is the one

scr_set_mode equ &bc0e
scr_set_border equ &bc38
cas_in_open equ &bc77
cas_in_direct equ &bc83
cas_in_close equ &bc7a
scr_set_ink equ &bc32
kl_rom_walk equ &bccb
mc_start_program equ &bd16
scr_initialise equ &bbff
txt_output equ &bb5a
km_wait_char equ &bb06
plus equ &40
loader_load_addr equ &100

org loader_load_addr

load_start:

;; load a file

load_file:
ld hl,end_filename-1
inc (hl)
ld hl,filename
ld b,end_filename-filename
push de
ld de,&c000
call cas_in_open
pop hl
call cas_in_direct
jp cas_in_close

filename:
defb "fadetest.bi0"
end_filename:

;;------------------------------------------------------------------
;; Start for loader. Detects stuff and initialises colour for screen and game

exe_start:
ld hl,(&be7d)
ld a,(hl)
ld (drive+1),a

ld c,&ff					;; disable all roms
ld hl,start					;; execution address for program
jp mc_start_program		;; start it


start:
call kl_rom_walk

drive:
ld a,0
ld hl,(&be7d)
ld (hl),a

defb &ed, &ff

call detect_plus
ld a,0
jr nz,noplus
ld a,1
noplus:
ld (plus),a

;; use firmware to set border colours
ld bc,0
call scr_set_border

ld hl,title_colours
call set_palette


ld de,&c000
call load_file

ld a,(plus)
or a
jr z,no_fade

di
defb &ed, &ff
call plus_unlock

ld bc,&7fb8
out (c),c

ld hl,&6400
ld de,cols
ld bc,32*2
ldir

ld de,cols
call init_fade_out

ld b,16
fadeit:
push bc
ld b,&f5
fadeit2:
in a,(c)
rra
jr nc,fadeit2
fadeit2b:
in a,(c)
rra
jr c,fadeit2b

call update_fade_cols

call update_fade_out
pop bc
djnz fadeit

ld de,cols
call init_fade_in

ld b,16
fadeit3:
push bc
ld b,&f5
fadeit4:
in a,(c)
rra
jr nc,fadeit4
fadeit4b:
in a,(c)
rra
jr c,fadeit4b

call update_fade_cols

call update_fade_in
pop bc
djnz fadeit3

ld bc,&7fa0
out (c),c
ei

no_fade:
ret

cols:
defs 32*2

set_palette:
push hl
ld a,0
call scr_set_mode
pop hl

ld b,16
xor a

set_colours:
push af
push bc
ld c,(hl)
inc hl
ld b,c
push hl
call scr_set_ink
pop hl
pop bc
pop af
inc a
djnz set_colours
ret


plus_unlock:
ld hl,plus_sequence
ld bc,&0bc00+15
pu1:
ld a,(hl)
out (c),a
inc hl
dec c
jr nz,pu1
ld a,&cd
out (c),a
ld a,&ee
out (c),a
ret
plus_sequence:
defb &ff, &0
defb &ff,&77,&b3,&51,&a8,&d4,&62,&39,&9c,&46,&2b,&15,&8a

;; detect plus
detect_plus:
  ld    bc,&f782
  out    (c),c
  dec    b
  ld    a,&f
  out    (c),a
  inc    b
  out    (c),c
  dec    b
  in    c,(c)
  cp    c 
  ret    
  
;; colours for screen
title_colours:
include "gfx/bin/loadscrfirmpal.asm"

include "fade.asm"

end exe_start