#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define grid_width_hex 10
#define grid_height_hex 32
#define MAX_TILES 8

#define X_INC 4
#define Y_INC 4

// value noise
void main()
{
	int grid[grid_height_hex*grid_width_hex];

	// fill
	{
		int x,y;
		
		for (y=0; y<grid_height_hex; y++)
		{
			for (x=0; x<grid_width_hex; x++)
			{
				grid[(grid_width_hex*y)+x] = -1;
			}
		}
	}
	
	
	
	// setup grid
{	
	int y = 0;
	while (y<grid_height_hex)
	{
		int x = 0;
		while (x<grid_width_hex)
		{
			grid[(grid_width_hex*y) + x] = rand()%MAX_TILES;
	
			if (x==(grid_width_hex-1))
				break;
			
			x  = x + X_INC;
			
			if (x>=grid_width_hex)
			{
				x = grid_width_hex-1;
			}
		}

		if (y==(grid_height_hex-1))
			break;
		y = y+Y_INC;
		if (y>=grid_height_hex)
		{
			y = grid_height_hex-1;
		}
	}
}
	
{
		int x,y;
		
		for (y=0; y<grid_height_hex; y++)
		{
			for (x=0; x<grid_width_hex; x++)
			{
				printf("%02x ", grid[(grid_width_hex*y)+x]&0x0ff );
			}
			printf("\n");
		}
	}

	// interpolate
	{
		int corners[4];
		int x,y;
		
		for (y=0; y<grid_height_hex; y++)
		{
			for (x=0; x<grid_width_hex; x++)
			{
				int val = grid[(grid_width_hex*y)+x];
				if (val==-1)
				{
					int px = x>>2;
					int nx = x+(4-(x&3));
					int py = y>>2;
					int ny = y+(4-(y&3));
					signed int xf = ((x&3)<<6)>>2;
					signed int yf = ((y&3)<<6)>>2;
					signed int xdiff1, xdiff2;
					signed int xvdiff;
					signed int xv1,xv2;
					signed int v;
					
					if (nx>=grid_width_hex)
					{
						nx = grid_width_hex-1;
					}
					if (ny>=grid_height_hex)
					{
						ny = grid_height_hex-1;
					}
					
					printf("x: %d y: %d px: %d py: %d nx: %d ny: %d xf: %f yf: %f\n",x,y,px,py,nx,ny,(float)xf/(float)(1<<6),(float)yf/(float)(1<<6));
					
					corners[0] = grid[(py*grid_width_hex)+px];
					corners[1] = grid[(py*grid_width_hex)+nx];
					corners[2] = grid[(ny*grid_width_hex)+px];
					corners[3] = grid[(ny*grid_width_hex)+nx];
					printf("corners %d %d %d %d\n", corners[0], corners[1], corners[2], corners[3]);
					
					xdiff1 = corners[1]-corners[0];
					xdiff2 = corners[3]-corners[2];
					
					printf("xdiff1 %d xdiff2 %d\n",xdiff1,xdiff2);

					xv1 = (xdiff1*xf)+(corners[0]<<6);
					xv2 = (xdiff2*xf)+(corners[2]<<6);

					printf("xv1 %f xv2 %f\n",(float)xv1/(float)(1<<6),(float)xv2/(float)(1<<6));

					xvdiff = xv2-xv1;

					printf("xvdiff %f \n",(float)xvdiff/(float)(1<<6));
					
					v =(((xvdiff*yf)>>6)+xv1)>>6;
					
					printf("v %d\n",v);

					grid[(grid_width_hex*y)+x] = v;
				}
			}
		}
	}
	
		
{
		int x,y;
		
		for (y=0; y<grid_height_hex; y++)
		{
			for (x=0; x<grid_width_hex; x++)
			{
				printf("%02x ", grid[(grid_width_hex*y)+x]&0x0ff );
			}
			printf("\n");
		}
	}
}