.globl _cpc_ClipLine
.module _cpc_ClipLine

;; input offsets:
;; 0,1 = x1
;; 2,3 = y1
;; 4,5 = x2
;; 6,7 = y2

;; 0 = within region
;; 1 = off min
;; 2 = off max

;; bit 7,6,5,4 = outcode 1 (y1,x1)
;; bit 3,2,1,0 = outcode 2 (y2,x2)

;; regions:
;; 0101 	0100 	0110
;; 0001 	0000 	0010
;; 1001 	1000 	1010

.area _CODE

;;------------------------------------------------------------------------

_cpc_ClipLine:
push ix

ld ix,#4
add ix,sp

xor a

ld l,2(ix)			;; y1
ld h,3(ix)

call check_ud		;; classify

rlca
rlca


ld l,0(ix)			;; x1
ld h,1(ix)
call check_lr		;; classify

rlca
rlca


ld l,6(ix)			;; y2
ld h,7(ix)
call check_ud

rlca
rlca

ld l,4(ix)			;; x2
ld h,5(ix)	
call check_lr		;; classify

pop ix
ld l,a
ld h,#0
ret

;;------------------------------------------------------------------------


check_lr:
ld de,(region_left)
ld bc,(region_right)
call check_range
ret

;;------------------------------------------------------------------------

check_ud:
ld de,(region_top)
ld bc,(region_bottom)
call check_range
ret

;;------------------------------------------------------------------------

check_range:
or a
sbc hl,de

;; +ve means it's either inside region or it's on the right side
;; -ve means it's off the left side
bit 7,h
jr z,ccl1

;; off left side
or #1
ret

ccl1:
;; is it off right side?
or a
sbc hl,bc

;; -ve means it's inside region
;; +ve means it's outside region
bit 7,h
ret nz

;; off right side
or #2
ret
;;------------------------------------------------------------------------
