#ifdef OVERSCAN

// these must match defs.s
#define CRTC_R1 46  //normally 40   44 for 176
#define CRTC_R9 8
#define CRTC_R6 33  //normally 25
#else

// these must match defs.s
#define CRTC_R1 40  //normally 40   44 for 176
#define CRTC_R9 8
#define CRTC_R6 25  //normally 25

#endif

// 256
// 176

#define SCR_WIDTH_PIXELS_MODE_0 (CRTC_R1*2*2)
#define SCR_WIDTH_PIXELS_MODE_1 (CRTC_R1*2*4)
#define SCR_WIDTH_PIXELS_MODE_2 (CRTC_R1*2*8)

// defined by R1 of the CRTC
#define SCR_WIDTH_BYTES (CRTC_R1*2)

// defined by R6 and R9 of the CRTC
#define SCR_HEIGHT_PIXELS (CRTC_R6*CRTC_R9)
#define HALF_SCR_HEIGHT_PIXELS (SCR_HEIGHT_PIXELS>>1)

#ifdef OVERSCAN
#define SCR_BASE 0x0188 
#else
// 0x0188 for 46 wide. 0x01a0 for 48 wide 
#define SCR_BASE 0xc000 
#endif

// 0x0188 -> 392 1656 chars to end
// 2048 

#define SCR_ADDR_FROM_COORD(x,y) \
	(unsigned char *)((SCR_BASE&0x0c000) +(((SCR_BASE&2047)+(x)+ (((y)>>3)*SCR_WIDTH_BYTES))&2047) +((((SCR_BASE&2047)+(x)+ (((y)>>3)*SCR_WIDTH_BYTES))/2048)*0x04000) + (((y)&7)*0x0800))

#define SCR_ADDR_FROM_CHAR_COORD(x,y) \
		SCR_ADDR_FROM_COORD((x<<1), (y<<3))
		
/*#define SCR_ADDR_FROM_COORD(x,y) \
	(SCR_BASE+((x)+(((y)>>3)*SCR_WIDTH_BYTES)+(((y)&7)*0x0800)))
*/
#define SCR_CHAR_TO_BYTEX0(x) \
	(x<<1)
	
#define SCR_CHAR_TO_LINEY0(y) \
	(y<<3)

/*
#define SCR_ADDR_FROM_CHAR0(x,y) \
	(SCR_BASE+((x)<<1)+((y)*SCR_WIDTH_BYTES))
*/

#define ARRAY_COUNT(x) \
	sizeof((x))/sizeof((x[0]))
	
#define LETTER_HEIGHT 8
enum
{
	HW_INK_WHITE=0,
	HW_INK_SEA_GREEN=2,
	HW_INK_PASTEL_YELLOW,
	HW_INK_BLUE,
	HW_INK_PURPLE,
	HW_INK_CYAN,
	HW_INK_PINK,
	HW_INK_BRIGHT_YELLOW=10,
	HW_INK_BRIGHT_WHITE,
	HW_INK_BRIGHT_RED,
	HW_INK_BRIGHT_MAGENTA,
	HW_INK_ORANGE,
	HW_INK_PASTEL_MAGENTA,
	HW_INK_BRIGHT_GREEN=18,
	HW_INK_BRIGHT_CYAN,
	HW_INK_BLACK,
	HW_INK_BRIGHT_BLUE,
	HW_INK_GREEN,
	HW_INK_SKY_BLUE,
	HW_INK_MAGENTA,
	HW_INK_PASTEL_GREEN,
	HW_INK_LIME,
	HW_INK_PASTEL_CYAN,
	HW_INK_RED,
	HW_INK_MAUVE,
	HW_INK_YELLOW,
	HW_INK_PASTEL_BLUE
};	


enum
{
	FW_INK_BLACK=0,
	FW_INK_BLUE,
	FW_INK_BRIGHT_BLUE,
	FW_INK_RED,
	FW_INK_MAGENTA,
	FW_INK_MAUVE,
	FW_INK_BRIGHT_RED,
	FW_INK_PURPLE,
	FW_INK_BRIGHT_MAGENTA,
	FW_INK_GREEN,
	FW_INK_CYAN,
	FW_INK_SKY_BLUE,
	FW_INK_YELLOW,
	FW_INK_WHITE,
	FW_INK_PASTEL_BLUE,
	FW_INK_ORANGE,
	FW_INK_PINK,
	FW_INK_PASTEL_MAGENTA,
	FW_INK_BRIGHT_GREEN,
	FW_INK_SEA_GREEN,
	FW_INK_BRIGHT_CYAN,
	FW_INK_LIME,
	FW_INK_PASTEL_GREEN,
	FW_INK_PASTEL_CYAN,
	FW_INK_BRIGHT_YELLOW,
	FW_INK_PASTEL_YELLOW,
	FW_INK_BRIGHT_WHITE,
};	

#define CPC_PEN0_MODE1 0x00
#define CPC_PEN1_MODE1 0xf0
#define CPC_PEN2_MODE1 0x0f
#define CPC_PEN3_MODE1 0xff

#define CPC_PIXEL0_MASK_MODE1 0x088
#define CPC_PIXEL1_MASK_MODE1 0x044
#define CPC_PIXEL2_MASK_MODE1 0x022
#define CPC_PIXEL3_MASK_MODE1 0x011

#define CPC_PEN0_MODE0  0x00
#define CPC_PEN1_MODE0   0x40 
#define CPC_PEN2_MODE0   0x04
#define CPC_PEN3_MODE0   0x44
#define CPC_PEN4_MODE0   0x10
#define CPC_PEN5_MODE0   0x50
#define CPC_PEN6_MODE0   0x14
#define CPC_PEN7_MODE0   0x54
#define CPC_PEN8_MODE0   0x01
#define CPC_PEN9_MODE0   0x41
#define CPC_PEN10_MODE0  0x05
#define CPC_PEN11_MODE0  0x45
#define CPC_PEN12_MODE0  0x11
#define CPC_PEN13_MODE0  0x51
#define CPC_PEN14_MODE0  0x15
#define CPC_PEN15_MODE0  0x55

#define CPC_PIXEL0_MASK_MODE0 0x0aa
#define CPC_PIXEL1_MASK_MODE0 0x055

#define CPC_KEY_CURSOR_LEFT 8
#define CPC_KEY_CURSOR_RIGHT 1
#define CPC_KEY_CURSOR_DOWN 2
#define CPC_KEY_CURSOR_UP 0
#define CPC_KEY_SPACE 47

#define CPC_KEY_JOY0_LEFT 74
#define CPC_KEY_JOY0_RIGHT 75
#define CPC_KEY_JOY0_UP 72
#define CPC_KEY_JOY0_DOWN 73
#define CPC_KEY_JOY0_FIRE1 76
#define CPC_KEY_JOY0_FIRE2 77

#define CPC_KEY_JOY1_LEFT 50
#define CPC_KEY_JOY1_RIGHT 51
#define CPC_KEY_JOY1_UP 48
#define CPC_KEY_JOY1_DOWN 49
#define CPC_KEY_JOY1_FIRE1 53
#define CPC_KEY_JOY1_FIRE2 52

#define CPC_KEY_Z 71
#define CPC_KEY_X 63
#define CPC_KEY_1 64
#define CPC_KEY_2 65
#define CPC_KEY_3 57
#define CPC_KEY_4 56
#define CPC_KEY_5 49
#define CPC_KEY_6 48
#define CPC_KEY_7 41
#define CPC_KEY_8 40
#define CPC_KEY_9 33
#define CPC_KEY_0 32

#define CPC_KEY_A 69
#define CPC_KEY_Q 67
#define CPC_KEY_O 34
#define CPC_KEY_P 27

#define CPC_KEY_F1 13
#define CPC_KEY_F2 14
#define CPC_KEY_F3 5
#define CPC_KEY_F4 20
#define CPC_KEY_F5 12
#define CPC_KEY_F6 4
#define CPC_KEY_F7 10
#define CPC_KEY_F8 11
#define CPC_KEY_F9 3

#define CPC_KEY_RETURN 18

#define CPC_KEY_ESC 66

extern int cpc_GetRRegister(void);
extern int cpc_Random(void);
extern int cpc_RandomInRange(int nRange);
extern void cpc_SetRandSeed(int nSeed);

/* scan keyboard and update "current" key map */
extern void cpc_ScanKeyboard();
/* ensure key table is initialised correctly */
extern void cpc_InitKeys();

/* perform a scan of the keyboard first */
/* key codes are the same as those used by CPC BASIC INKEY command */

/* returns true if key was pressed last time but released this time */
extern int cpc_TestKeyReleased(int);
extern int cpc_TestKeyReleasedList(const unsigned char *, int);

/* returns true if key was released last time, but pressed now */
extern int cpc_TestKeyPressed(int);
extern int cpc_TestKeyDown(int);
extern int cpc_TestKeyHeldList(const unsigned char *, int);

/* copy "current" keys to "previous" keys, "current" and "previous" are used with key pressed and key released */
extern int cpc_BackupKeys();

extern int cpc_InVsync(void);
extern void cpc_WaitVsyncEnd(void);
extern void cpc_WaitVsyncStart(void);

extern void cpc_EnableIM1Interrupt();
extern void cpc_EnableIM2Interrupt();

/* install a IM1 maskable interrupt handler */
extern void cpc_InstallIM1Interrupt(void *addr);

/* install a NMI maskable interrupt handler */
extern void cpc_InstallNMIInterrupt(void *addr);

extern void cpc_InstallIM2Interrupt(void *addr, int vector);
extern void cpc_SprMask0(unsigned char * scraddr, const unsigned char * pixeladdr, int widthbytes, int heightlines);
/* limited to 256 lines tall */
extern void cpc_SprReplace(unsigned char * scraddr, const unsigned char * pixeladdr, int widthbytes, int heightlines);
extern void cpc_SprReplaceLarge(unsigned char * scraddr, const unsigned char * pixeladdr, int widthbytes, int heightlines);
extern unsigned char *cpc_GetScrAddr(int bytex,int liney);
extern void cpc_InitScrTable();
extern void cpc_InitMaskTable0();
extern void cpc_SetColourHW(int pen, int hwink);
extern void cpc_SetBorderHW(int hwink);
extern void cpc_SetColourFW(int pen, int fwink);
extern void cpc_SetBorderFW(int fwink);
extern void cpc_SetModeFW(int mode);
/* clear screen */
extern void cpc_CLS(int encodedpen);
extern void cpc_ClearRectangle(unsigned char *scraddr, int WidthInBytes, int HeightInLines, int Colour);
extern void cpc_DisplayString(unsigned char *scraddr, const unsigned char *text);
extern void cpc_ClearRectangle(unsigned char *scraddr, int width, int height, int colour);
extern void cpc_CopyRectangle(unsigned char *scraddrsrc, unsigned char *scraddrdest, int width, int height);

extern void cpc_SetLetterPens(const unsigned char *pens);


extern void cpc_DrawFastLine(unsigned short x1, unsigned short y1, unsigned short x2, unsigned short y2, unsigned char colour);
extern void cpc_SetClipRegion(unsigned short left, unsigned short top, unsigned short right, unsigned short bottom);

typedef struct
{
	unsigned short x1;
	unsigned short y1;
	unsigned short x2;
	unsigned short y2;
} clip_results;

/* 0 means no clip, other values indicate clip */
extern int cpc_ClipLine(unsigned short x1, unsigned short y1, unsigned short x2, unsigned short y2);
extern clip_results *cpc_PerformClipLine(unsigned short x1, unsigned short y1, unsigned short x2, unsigned short y2, int nResult);

/* sets 14 registers from 0 to 13 */
extern void cpc_SetCRTCRegisters(const unsigned char *registerData);
/* set a single crtc register */
extern void cpc_CRTCWriteRegister(int Register, unsigned char Data);

/* set more than one colour. Starts at colour 0, and sets "count" number of colours. e.g. set count to 16 for mode 0 */
extern void cpc_SetColoursHW(int count, const unsigned char *Colours);

extern int cpc_StringLength(const char *sText);

extern void cpc_Reset();

/* non overlapping move using LDIR */
extern void cpc_MoveMem(unsigned char *src, unsigned char *dest, unsigned int length);

#define MF_MODE_MASK 0x03
#define MF_LOWER_ROM_DISABLE (1<<2)
#define MF_UPPER_ROM_DISABLE (1<<3)
#define MF_INTERRUPT_COUNTER_RESET (1<<4)

// set mode and rom state using hardware
extern void cpc_SetMultiFunctionHW(int mode);

#define cpc_DisableMaskableInterrupts() __asm  di __endasm
#define cpc_EnableMaskableInterrupts() __asm  ei __endasm

#define DEBUG_BREAK \
	__asm .db 0x0ed,0x0ff __endasm
	 

